| NANO100_BSP V3.05.000 The Board Support Package for Nano100BN Series

Macros | Functions | Variables
FMC Exported Functions
NANO100 Device Driver » FMC Driver » FMC Exported Constants
Collaboration diagram for FMC Exported Functions:

## Macros
#define | FMC_SET_APROM_BOOT()
| This macro selects booting from APROM. More...
#define | FMC_SET_LDROM_BOOT()
| This macro selects booting from LDROM. More...
#define | FMC_ENABLE_AP_UPDATE()
| This macro enables APROM update function. More...
#define | FMC_DISABLE_AP_UPDATE()
| This macro disables APROM update function. More...
#define | FMC_ENABLE_CFG_UPDATE()
| This macro enables User Configuration update function. More...
#define | FMC_DISABLE_CFG_UPDATE()
| This macro disables User Configuration update function. More...
#define | FMC_ENABLE_LD_UPDATE()
| This macro enables LDROM update function. More...
#define | FMC_DISABLE_LD_UPDATE()
| This macro disables LDROM update function. More...
#define | FMC_ENABLE_ISP()
| This macro enables ISP function. More...
#define | FMC_DISABLE_ISP()
| This macro disables ISP function. More...
#define | FMC_GET_FAIL_FLAG()
| This macro gets ISP fail flag value. More...
#define | FMC_CLR_FAIL_FLAG()
| This macro clears ISP fail flag. More...

## Functions
void | FMC_Close (void)
| Disable FMC ISP function. More...
int32_t | FMC_Erase (uint32_t u32PageAddr)
| Execute ISP command to erase a flash page. The page size is 512 bytes. More...
int32_t | FMC_GetBootSource (void)
| Get the current boot source. More...
void | FMC_Open (void)
| Enable FMC ISP function. More...
uint32_t | FMC_Read (uint32_t u32Addr)
| Execute ISP command to read a word from flash. More...
uint32_t | FMC_ReadCID (void)
| Read company ID. More...
uint32_t | FMC_ReadPID (void)
| Read product ID. More...
uint32_t | FMC_ReadUCID (uint32_t u32Index)
| This function reads one of the four UCID. More...
uint32_t | FMC_ReadUID (uint32_t u32Index)
| This function reads one of the three UID. More...
uint32_t | FMC_ReadDataFlashBaseAddr (void)
| Get the base address of Data Flash if enabled. More...
void | FMC_SetVectorPageAddr (uint32_t u32PageAddr)
| This function will force re-map assigned flash page to CPU address 0x0. More...
uint32_t | FMC_GetVectorPageAddr (void)
| Obtain the current vector page address setting. More...
int32_t | FMC_Write (uint32_t u32Addr, uint32_t u32Data)
| Execute ISP command to program a word to flash. More...
int32_t | FMC_ReadConfig (uint32_t *u32Config, uint32_t u32Count)
| Execute ISP command to read User Configuration. More...
int32_t | FMC_WriteConfig (uint32_t *u32Config, uint32_t u32Count)
| Execute ISP command to write User Configuration. More...

## Variables
int32_t | g_FMC_i32ErrCode

## Detailed Description

## Macro Definition Documentation

## ◆ FMC_CLR_FAIL_FLAG

#define FMC_CLR_FAIL_FLAG | ( |  | ) |

This macro clears ISP fail flag.

Parameters

  None |

Returns
  None

Definition at line 172 of file fmc.h.

## ◆ FMC_DISABLE_AP_UPDATE

#define FMC_DISABLE_AP_UPDATE | ( |  | ) |

This macro disables APROM update function.

Parameters

  None |

Returns
  None

Definition at line 108 of file fmc.h.

## ◆ FMC_DISABLE_CFG_UPDATE

#define FMC_DISABLE_CFG_UPDATE | ( |  | ) |

This macro disables User Configuration update function.

Parameters

  None |

Returns
  None

Definition at line 124 of file fmc.h.

## ◆ FMC_DISABLE_ISP

#define FMC_DISABLE_ISP | ( |  | ) |

This macro disables ISP function.

Parameters

  None |

Returns
  None

Definition at line 156 of file fmc.h.

## ◆ FMC_DISABLE_LD_UPDATE

#define FMC_DISABLE_LD_UPDATE | ( |  | ) |

This macro disables LDROM update function.

Parameters

  None |

Returns
  None

Definition at line 140 of file fmc.h.

## ◆ FMC_ENABLE_AP_UPDATE

#define FMC_ENABLE_AP_UPDATE | ( |  | ) |

This macro enables APROM update function.

Parameters

  None |

Returns
  None

Definition at line 100 of file fmc.h.

## ◆ FMC_ENABLE_CFG_UPDATE

#define FMC_ENABLE_CFG_UPDATE | ( |  | ) |

This macro enables User Configuration update function.

Parameters

  None |

Returns
  None

Definition at line 116 of file fmc.h.

## ◆ FMC_ENABLE_ISP

#define FMC_ENABLE_ISP | ( |  | ) |

This macro enables ISP function.

Parameters

  None |

Returns
  None

Definition at line 148 of file fmc.h.

## ◆ FMC_ENABLE_LD_UPDATE

#define FMC_ENABLE_LD_UPDATE | ( |  | ) |

This macro enables LDROM update function.

Parameters

  None |

Returns
  None

Definition at line 132 of file fmc.h.

## ◆ FMC_GET_FAIL_FLAG

#define FMC_GET_FAIL_FLAG | ( |  | ) |

This macro gets ISP fail flag value.

Parameters

  None |

Returns
  ISP fail flag value.

Definition at line 164 of file fmc.h.

## ◆ FMC_SET_APROM_BOOT

#define FMC_SET_APROM_BOOT | ( |  | ) |

This macro selects booting from APROM.

Parameters

  None |

Returns
  None

Definition at line 84 of file fmc.h.

## ◆ FMC_SET_LDROM_BOOT

#define FMC_SET_LDROM_BOOT | ( |  | ) |

This macro selects booting from LDROM.

Parameters

  None |

Returns
  None

Definition at line 92 of file fmc.h.

## Function Documentation

## ◆ FMC_Close()

void FMC_Close | ( | void |  | ) |

Disable FMC ISP function.

Returns
  None

Definition at line 38 of file fmc.c.

## ◆ FMC_Erase()

int32_t FMC_Erase | ( | uint32_t | u32PageAddr | ) |

Execute ISP command to erase a flash page. The page size is 512 bytes.

Parameters

  [in] | u32PageAddr | Address of the flash page to be erased. It must be a 512-byte aligned address.

Returns
  ISP page erase success or not.

Return values

  0 | Success
  -1 | Erase failed or time-out

Note
  Global error code g_FMC_i32ErrCode -1 time-out error

Definition at line 54 of file fmc.c.

Here is the caller graph for this function:

## ◆ FMC_GetBootSource()

int32_t FMC_GetBootSource | ( | void |  | ) |

Get the current boot source.

Returns
  The current boot source.

Return values

  0 | Is boot from APROM.
  1 | Is boot from LDROM.

Definition at line 79 of file fmc.c.

## ◆ FMC_GetVectorPageAddr()

uint32_t FMC_GetVectorPageAddr | ( | void |  | ) |

Obtain the current vector page address setting.

Returns
  The vector page address.

Definition at line 256 of file fmc.c.

## ◆ FMC_Open()

void FMC_Open | ( | void |  | ) |

Enable FMC ISP function.

Returns
  None

Definition at line 92 of file fmc.c.

## ◆ FMC_Read()

uint32_t FMC_Read | ( | uint32_t | u32Addr | ) |

Execute ISP command to read a word from flash.

Parameters

  [in] | u32Addr | Address of the flash location to be read. It must be a word aligned address.

Returns
  The word data read from specified flash address.

Definition at line 104 of file fmc.c.

Here is the caller graph for this function:

## ◆ FMC_ReadCID()

uint32_t FMC_ReadCID | ( | void |  | ) |

Read company ID.

Returns
  The company ID. Return 0xFFFFFFFF if read failed.

Note
  Global error code g_FMC_i32ErrCode -1 Read time-out

Definition at line 129 of file fmc.c.

## ◆ FMC_ReadConfig()

int32_t FMC_ReadConfig | ( | uint32_t * | u32Config,
|  | uint32_t | u32Count
| ) |  |

Execute ISP command to read User Configuration.

Parameters

  [out] | u32Config | A two-word array. u32Config[0] holds CONFIG0, while u32Config[1] holds CONFIG1.
  [in] | u32Count | Avaliable word count in u32Config.

Returns
  Success or not.

Return values

  0 | Success.
  -1 | Invalid parameter.

Definition at line 296 of file fmc.c.

Here is the call graph for this function:

## ◆ FMC_ReadDataFlashBaseAddr()

uint32_t FMC_ReadDataFlashBaseAddr | ( | void |  | ) |

Get the base address of Data Flash if enabled.

Returns
  Base address of Data Flash

Definition at line 226 of file fmc.c.

## ◆ FMC_ReadPID()

uint32_t FMC_ReadPID | ( | void |  | ) |

Read product ID.

Returns
  The product ID. Return 0xFFFFFFFF if read failed.

Note
  Global error code g_FMC_i32ErrCode -1 Read time-out

Definition at line 153 of file fmc.c.

## ◆ FMC_ReadUCID()

uint32_t FMC_ReadUCID | ( | uint32_t | u32Index | ) |

This function reads one of the four UCID.

Parameters

  [in] | u32Index | Index of the UCID to read. u32Index must be 0, 1, 2, or 3.

Returns
  The UCID. Return 0xFFFFFFFF if read failed.

Note
  Global error code g_FMC_i32ErrCode -1 Read time-out

Definition at line 178 of file fmc.c.

## ◆ FMC_ReadUID()

uint32_t FMC_ReadUID | ( | uint32_t | u32Index | ) |

This function reads one of the three UID.

Parameters

  [in] | u32Index | Index of the UID to read. u32Index must be 0, 1, or 2.

Returns
  The UID. Return 0xFFFFFFFF if read failed.

Note
  Global error code g_FMC_i32ErrCode -1 Read time-out

Definition at line 204 of file fmc.c.

## ◆ FMC_SetVectorPageAddr()

void FMC_SetVectorPageAddr | ( | uint32_t | u32PageAddr | ) |

This function will force re-map assigned flash page to CPU address 0x0.

Parameters

  [in] | u32PageAddr | Address of the page to be mapped to CPU address 0x0.

Returns
  None

Note
  Global error code g_FMC_i32ErrCode -1 time-out

Definition at line 239 of file fmc.c.

## ◆ FMC_Write()

int32_t FMC_Write | ( | uint32_t | u32Addr,
|  | uint32_t | u32Data
| ) |  |

Execute ISP command to program a word to flash.

Parameters

  [in] | u32Addr | Address of the flash location to be programmed. It must be a word aligned address.
  [in] | u32Data | The word data to be programmed.

Returns
  None

Definition at line 269 of file fmc.c.

Here is the caller graph for this function:

## ◆ FMC_WriteConfig()

int32_t FMC_WriteConfig | ( | uint32_t * | u32Config,
|  | uint32_t | u32Count
| ) |  |

Execute ISP command to write User Configuration.

Parameters

  [in] | u32Config | A two-word array. u32Config[0] holds CONFIG0, while u32Config[1] holds CONFIG1.
  [in] | u32Count | Available word count in u32Config.

Returns
  Success or not.

Return values

  0 | Success.
  -1 | Invalid parameter.

Definition at line 315 of file fmc.c.

Here is the call graph for this function:

## Variable Documentation

## ◆ g_FMC_i32ErrCode

int32_t g_FMC_i32ErrCode

Definition at line 32 of file fmc.c.